﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;


namespace DataGrid_CurrentRowData
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void btnConfigProperties_Click_1(object sender, RoutedEventArgs e)
        {
            CellValuePresenter presenter = (sender as Button).TemplatedParent as CellValuePresenter;
            if (presenter != null)
            {
                var rowData = presenter.Record;                
                MessageBox.Show("Record Idnex: "+ rowData.Index + "\nName: " + rowData.Cells["Name"].Value +"\nAge: " + rowData.Cells["Age"].Value,"Personal Details");
            }
        }
    }

    public class WViewModel : INotifyPropertyChanged
    {

        ObservableCollection<Worker> listOfWorkers;

        public WViewModel()
        {
            listOfWorkers = new ObservableCollection<Worker>();

            listOfWorkers.Add(new Worker("Vivian", 22, "QA"));
            listOfWorkers.Add(new Worker("Andy", 23, "DS"));
            listOfWorkers.Add(new Worker("Peter", 24, "QA"));

        }

        public ObservableCollection<Worker> ListOfWorkers
        {
            get { return listOfWorkers; }

            set
            {
                if (value != listOfWorkers)
                {
                    listOfWorkers = value;
                    OnPropertyChanged("ListOfWorkers");
                }
            }
        }


        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public event PropertyChangedEventHandler PropertyChanged;

    }

    public class Worker : INotifyPropertyChanged
    {
        public Worker() { }

        public Worker(string name, int age, string job)
        {
            this.Name = name;
            this.Age = age;
            this.JobTitle = job;
        }


        private string name;

        public string Name
        {
            get
            {
                return this.name;
            }

            set
            {
                if (value != this.name)
                {
                    this.name = value;
                    NotifyPropertyChanged("Name");
                }
            }
        }

        private int age;

        public int Age
        {
            get
            {
                return this.age;
            }

            set
            {
                if (value != this.age)
                {
                    this.age = value;
                    NotifyPropertyChanged("Age");
                }
            }
        }


        private string jobTitle;

        public string JobTitle
        {
            get
            {
                return this.jobTitle;
            }

            set
            {
                if (value != this.jobTitle)
                {
                    this.jobTitle = value;
                    NotifyPropertyChanged("JobTitle");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


    }
}
